<?php

header('Content-Type: application/json');

include('../../php/conn.php');

// Actualizando zona horaria del servidor
  $q_timezone = "SET TIME_ZONE = 'America/Lima'";

  if ($res = mysqli_query($enlace, $q_timezone)) {
  }

  date_default_timezone_set('America/Lima');

// Permite obtener el nombde de casa mes
  function nombre_meses($num_mes){
    if ($num_mes == 1){
      return "ENERO";
    }
    if ($num_mes == 2){
      return "FEBRERO";
    }
    if ($num_mes == 3){
      return "MARZO";
    }
    if ($num_mes == 4){
      return "ABRIL";
    }
    if ($num_mes == 5){
      return "MAYO";
    }
    if ($num_mes == 6){
      return "JUNIO";
    }
    if ($num_mes == 7){
      return "JULIO";
    }
    if ($num_mes == 8){
      return "AGOSTO";
    }
    if ($num_mes == 9){
      return "SEPTIEMBRE";
    }
    if ($num_mes == 10){
      return "OCTUBRE";
    }
    if ($num_mes == 11){
      return "NOVIEMBRE";
    }
    if ($num_mes == 12){
      return "DICIEMBRE";
    }
  }

// Inicia el proceso condicional
  switch ($_GET["accion"]) {
    case 'get_ListaRacks':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM, CR.nom_rack,
                         CR.des_rack, CR.fecha_rack,
                         CR.usuario_rack, CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_Racks':
      $r = array();
      $estado = 0;

      $estado = $_GET["Estado"];
      $id_rack = $_GET["Id_Rack"];
      $nom_rack = $_GET["Nom_Rack"];
      $id_horno = $_GET["Id_Horno"];
      $des_rack = $_GET["Des_Rack"];
      $usuario_rack = $_GET["Usuario_Rack"];

      if ($estado == 'N'){
        $q_save = "INSERT INTO Cabecera_Rack(nom_rack, des_rack, id_horno, usuario_rack) VALUES(";
        $q_save .= "'".$nom_rack."', ";
        $q_save .= "'".$des_rack."', ";
        $q_save .= $id_horno.", ";
        $q_save .= "'".$usuario_rack."')";
      }

      if ($estado == 'M'){
        $q_save = "UPDATE  Cabecera_Rack SET ";
        $q_save .= "       nom_rack = '".$nom_rack."', ";
        $q_save .= "       des_rack = '".$des_rack."', ";
        $q_save .= "       id_horno = ".$id_horno;
        $q_save .= " WHERE Id = ".$id_rack;
      }

      if ($estado == 'E'){
        $q_save = "DELETE FROM Cabecera_Rack";
        $q_save .= " WHERE Id = ".$id_rack;
      }

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaTipoBlancoFundente':
      $r = array();
      $estado = 0;

      $q_TipoBlanco = "SELECT Id,
                              nom_tipoblanco
                         FROM tbconfig_RackTipoBlancoFundente
                        WHERE estado_tipoblanco = 'A'";

      if ($res_TipoBlanco = mysqli_query($enlace, $q_TipoBlanco)) {
        if (mysqli_num_rows($res_TipoBlanco) > 0) {
          while($row_TipoBlanco = mysqli_fetch_assoc($res_TipoBlanco)) {
            array_push($r, $row_TipoBlanco);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_RackMuestra':
      $r = array();
      $estado = 0;
      $exists = 0;

      $nom_muestra = $_GET["nom_muestra"];
      $tipo_blanco = $_GET["tipo_blanco"];
      $dosificacion = $_GET["dosificacion"];
      $id_rack = $_GET["id_rack"];
      $usuario_muestra = $_GET["usuario_muestra"];

      // Busca la muestra en las tablas de ventas
        $q_RackMuestra = "SELECT  C.Id_Pedido,
                                  D.Id AS Id_Detalle,
                                  D.Cod_Interno,
                                  D.Nom_Muestra,
                                  LOWER(D.Elemento_Analisis) AS Elemento_Analisis,
                                  TA.Num_Replica,
                                  PV.Id_MedioPago
                            FROM  _max_labperu_DetallePedido D
                                  INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                  INNER JOIN _max_labperu_TipoAnalisis TA ON D.Tipo_Analisis = TA.Id
                                  INNER JOIN _max_labperu_PagoVenta PV ON C.Id_Pedido = PV.Id_Pedido
                                  INNER JOIN _max_labperu_MedioPago MP ON PV.Id_MedioPago = MP.Id
                           WHERE  D.Cod_Interno = '".$nom_muestra."'
                             AND  (LOWER(D.Elemento_Analisis) LIKE '%au%'
                             OR  LOWER(D.Elemento_Analisis) LIKE '%ag%')";

      if ($res_RackMuestra = sqlsrv_query($enlacehost, $q_RackMuestra)) {
        while($row_RackMuestra = sqlsrv_fetch_array($res_RackMuestra)) {
          $exists = 1;

          // Comprobando si es una muestra Newmont
            $q_newmont = "SELECT  COUNT(Id) AS _EXISTS
                            FROM  _max_labperu_DetallePedido
                           WHERE  Cod_Interno = '".$nom_muestra."'
                             AND  IdProductos_Combo LIKE '%43121%'";

            if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
              while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
                if ($row_newmont["_EXISTS"] == 1){
                  $estado = 5;

                  echo json_encode(array('estado' => $estado));

                  return;
                }
              }
            }

          // Comprobar que la muestra no exista en otro Rack
            $q_exists = "SELECT  COUNT(Id) AS _COUNT
                           FROM  Detalle_Rack
                          WHERE  ci_muestra = '".$nom_muestra."'
                            AND  is_Reanalisis = 0
                            AND  Id_Rack <> ".$id_rack;

            if ($res_exists = mysqli_query($enlace, $q_exists)) {
              if (mysqli_num_rows($res_exists) > 0) {
                while($row_exists = mysqli_fetch_assoc($res_exists)) {
                  if ($row_exists["_COUNT"] > 0){
                    $estado = 3;

                    echo json_encode(array('estado' => $estado));

                    return;
                  }
                }
              }
            }

          // Si no existe en el Rack lo ingresa como nuevo
            $q_exists = "SELECT  COUNT(Id) AS _COUNT
                           FROM  Detalle_Rack
                          WHERE  ci_muestra = '".$nom_muestra."'
                            AND  is_Reanalisis = 0
                            AND  Id_Rack = ".$id_rack;

            if ($res_exists = mysqli_query($enlace, $q_exists)) {
              if (mysqli_num_rows($res_exists) > 0) {
                while ($row_exists = mysqli_fetch_assoc($res_exists)) {
                  if ($row_exists["_COUNT"] == 0){
                    // Grabando los datos en la tabla de Detalle de Rack
                      $q_InsertDetalle = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                                                   ci_muestra, nom_muestra, is_Au, is_Ag,
                                                                   Id_TipoBlancoFundente, Dosificacion, Usuario_Muestra, num_replica, Id_MedioPago, is_Reanalisis) VALUES(";
                      $q_InsertDetalle .= $id_rack.", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_Pedido"].", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_Detalle"].", 1, ";
                      $q_InsertDetalle .= "'".$row_RackMuestra["Cod_Interno"]."', ";
                      $q_InsertDetalle .= "'".$row_RackMuestra["Nom_Muestra"]."', ";

                      $is_au = 0;
                      $pos = strpos($row_RackMuestra["Elemento_Analisis"], 'au');

                      if ($pos !== false){
                        $is_au = 1;
                      }

                      $is_ag = 0;
                      $pos = strpos($row_RackMuestra["Elemento_Analisis"], 'ag');

                      if ($pos !== false){
                        $is_ag = 1;
                      }

                      $q_InsertDetalle .= $is_au.", ";
                      $q_InsertDetalle .= $is_ag.", ";
                      $q_InsertDetalle .= $tipo_blanco.", ";
                      $q_InsertDetalle .= "'".$dosificacion."', ";
                      $q_InsertDetalle .= "'".$usuario_muestra."', ";
                      $q_InsertDetalle .= $row_RackMuestra["Num_Replica"].", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_MedioPago"].", 0)";

                      if ($res_InsertDetalle = mysqli_query($enlace, $q_InsertDetalle)) {
                        $id_detalle_rack = mysql_insert_id();
                      }
                  }
                  else{
                    // Si la muestra fue registrada previamente y no tiene pesos, puede continuar, porque el sistema pudo caerse. Pero, si ya tiene pesos no debería permitir su registro
                    $q_detalle_rack = "SELECT  Id
                                         FROM  Detalle_Rack
                                        WHERE  ci_muestra = '".$nom_muestra."'
                                          AND  is_Reanalisis = 0
                                          AND  Id_Rack = ".$id_rack."
                                          AND  (SELECT COUNT(DRP.Id) FROM Detalle_Rack_Pesos DRP WHERE DRP.Id_Detalle_Rack = Detalle_Rack.Id) = 0";

                    if ($res_detalle_rack = mysqli_query($enlace, $q_detalle_rack)) {
                      if (mysqli_num_rows($res_detalle_rack) > 0) {
                        while ($row_detalle_rack = mysqli_fetch_assoc($res_detalle_rack)) {
                          $id_detalle_rack = $row_detalle_rack["Id"];
                        }
                      }
                      else{
                        // Si entra es porque tiene pesos registrados en este Rack y no debería continuar
                          $estado = 4;

                          echo json_encode(array('estado' => $estado));

                          return;
                      }
                    }
                  }
                }
              }
            }

          // Obteniendo el número de muestras registradas en el Rack, para obtener el correlativo de Crisol
            $num_crisol = 0;

            $q_numcrisol = "SELECT COUNT(Id) AS _COUNT
                              FROM  Detalle_Rack_Pesos
                             WHERE  Id_Detalle_Rack IN (SELECT Id
                                                          FROM Detalle_Rack
                                                         WHERE Id_Rack = ".$id_rack.")";

            if ($res_numcrisol = mysqli_query($enlace, $q_numcrisol)) {
              if (mysqli_num_rows($res_numcrisol) > 0) {
                while ($row_numcrisol = mysqli_fetch_assoc($res_numcrisol)) {
                  $num_crisol = $row_numcrisol["_COUNT"];
                }
              }
            }

          // Armando el Select para el DataGridView
            $w = 1;

            while ($w <= $row_RackMuestra["Num_Replica"]){
              $q_select = "SELECT ".$id_detalle_rack." AS Id_Detalle_Rack,
                                  ".($num_crisol + 1)." AS Num_Crisol,
                                  '".$row_RackMuestra["Cod_Interno"]."' AS Nom_Muestra,
                                  '' AS Peso_Muestra";

              if ($res_select = mysqli_query($enlace, $q_select)) {
                if (mysqli_num_rows($res_select) > 0) {
                  while ($row_select = mysqli_fetch_assoc($res_select)) {
                    array_push($r, $row_select);
                  }
                }
              }

              // // Guardando ficticios en la tabla de Pesos
              //   $q_InsertPesos = "INSERT INTO Detalle_Rack_Pesos (Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra) VALUES(";
              //   $q_InsertPesos .= $id_detalle_rack.", ";
              //   $q_InsertPesos .= ($num_crisol + 1).", ";
              //   $q_InsertPesos .= "'".$nom_muestra."', 0)";

              //   if ($res_InsertPesos = mysqli_query($enlace, $q_InsertPesos)) {
              //   }

              $num_crisol += 1;
              $w += 1;
            }
        }

        $estado = (($exists == 1) ? 1 : 2);
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'eliminar_DetalleRack':
      $r = array();
      $estado = 0;

      $id_detallerack = $_GET["id_detallerack"];

      $q_delete = "DELETE FROM Detalle_Rack";
      $q_delete .= " WHERE Id = ".$id_detallerack;

      if ($res = mysqli_query($enlace, $q_delete)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_PesosRack':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Peso"];
      $Id_Detalle_Rack = $_GET["Id_Detalle_Rack"];
      $Num_Crisol = $_GET["Num_Crisol"];
      $Nom_Muestra = $_GET["Nom_Muestra"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Peso = $_GET["Usuario_Peso"];
      $Tipo_InsertUpdate = $_GET["Tipo_InsertUpdate"];

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $date = date('Y-m-d');
          $time = date('H:i:s');

          if ($Tipo_InsertUpdate == 'I'){
            $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
          }
          else{
            $q_SavePeso = "UPDATE Detalle_Rack_Pesos SET ";
            $q_SavePeso .= "FechaPeso_Muestra = '".($date.' ' .$time)."', ";
            $q_SavePeso .= "Peso_Muestra = ".$Peso_Muestra.", ";
            $q_SavePeso .= "UsuarioPeso_Muestra = '".$Usuario_Peso."' ";
            $q_SavePeso .= "WHERE Id_Detalle_Rack = ".$Id_Detalle_Rack." ";
            $q_SavePeso .= "AND Num_Crisol = ".$Num_Crisol;
          }
        }

      // Para el peso de Blanco Fundente
        if ($Tipo_Peso == 'BF'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
          $q_SavePeso .= $Id_Detalle_Rack.", ";
          $q_SavePeso .= $Num_Crisol.", ";
          $q_SavePeso .= "'".$Nom_Muestra."', ";
          $q_SavePeso .= $Peso_Muestra.", ";
          $q_SavePeso .= "'".$Usuario_Peso."')";
        }

      // Para el peso de Blanco Pulverizado
        if ($Tipo_Peso == 'BP'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
        }

      // Para el peso de Material de Referencia
        if ($Tipo_Peso == 'MR'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
        }

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_DetalleMuestrasRack':
      $r = array();
      $id_detalle_rack = 0;

      $id_rack = $_GET["id_rack"];
      $tipo_muestra = $_GET["tipo_muestra"];
      $nom_muestra = $_GET["nom_muestra"];
      $tipo_blanco = $_GET["tipo_blanco"];
      $dosif = $_GET["dosif"];
      $replicas = $_GET["replicas"];

      if ($tipo_muestra == "BF"){
        $tipo_muestra = 2;
      }

      if ($tipo_muestra == "BP"){
        $tipo_muestra = 3;
      }

      if ($tipo_muestra == "MR"){
        $tipo_muestra = 4;
      }

      $q_insert = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                            ci_muestra, nom_muestra, is_Au, is_Ag,
                                            Id_TipoBlancoFundente, Dosificacion, num_replica, Id_MedioPago,
                                            is_Reanalisis) VALUES(
                  ".$id_rack.", 0, 0, ".$tipo_muestra.",
                  '".$nom_muestra."', '".$nom_muestra."', 0, 0,
                  ".$tipo_blanco.", '".$dosif."', ".$replicas.", 0, 0)";

      if ($res_insert = mysqli_query($enlace, $q_insert)) {
        $max_id = "SELECT MAX(Id) AS _MAX
                     FROM Detalle_Rack";

        if ($res_max_id = mysqli_query($enlace, $max_id)) {
          if (mysqli_num_rows($res_max_id) > 0) {
            while ($row_max_id = mysqli_fetch_assoc($res_max_id)) {
              $id_detalle_rack = $row_max_id["_MAX"];
            }
          }
        }
      }
      else{
        $id_detalle_rack = 0;
      }

      echo json_encode(array('id_detalle_rack' => $id_detalle_rack));

      break;

    case 'update_DatosPesos':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Peso"];
      $Id_Rack = $_GET["Id_Rack"];
      $CI_Muestra = $_GET["CI_Muestra"];
      $Tipo_Blanco = $_GET["Tipo_Blanco"];
      $Dosificacion = $_GET["Dosificacion"];

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $q_update = "UPDATE Detalle_Rack SET 
                              Id_TipoBlancoFundente = ".$Tipo_Blanco.",
                              Dosificacion = '".$Dosificacion."'
                        WHERE Id_Rack = ".$Id_Rack."
                          AND ci_muestra = '".$CI_Muestra."'";
        }

      // Para el peso de Régulo
      if ($Tipo_Peso == 'R'){
        
      }

      // Para el peso de Doré
      if ($Tipo_Peso == 'D'){

      }

      // Para el peso de Au
      if ($Tipo_Peso == 'Au'){

      }

      if ($res = mysqli_query($enlace, $q_update)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRackMuestras':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.nom_muestra,
                                DRP.Peso_Muestra,
                                TB.nom_tipoblanco,
                                DR.Dosificacion,
                                DR.Id
                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DR.Id_TipoBlancoFundente = TB.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_NumCrisol':
      $r = array();
      $estado = 0;
      $num_crisol = 0;

      $id_rack = $_GET["id_rack"];

      $q_numcrisol = "SELECT COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT Id
                                                    FROM Detalle_Rack
                                                   WHERE Id_Rack = ".$id_rack.")";

      if ($res_numcrisol = mysqli_query($enlace, $q_numcrisol)) {
        if (mysqli_num_rows($res_numcrisol) > 0) {
          $estado = 1;

          while ($row_numcrisol = mysqli_fetch_assoc($res_numcrisol)) {
            $num_crisol = $row_numcrisol["_COUNT"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'num_crisol' => $num_crisol));

      break;

    case 'get_NumBlancoFundente':
      $r = array();
      $estado = 0;
      $num_blanco = 0;

      $id_rack = $_GET["id_rack"];
      $tipo_blanco = $_GET["tipo_blanco"];

      $q_numblanco = "SELECT COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT Id
                                                    FROM Detalle_Rack
                                                   WHERE Id_Rack = ".$id_rack."
                                                     AND Rack_TipoMuestra = 2
                                                     AND Id_TipoBlancoFundente = ".$tipo_blanco.")";

      if ($res_numblanco = mysqli_query($enlace, $q_numblanco)) {
        if (mysqli_num_rows($res_numblanco) > 0) {
          $estado = 1;

          while ($row_numblanco = mysqli_fetch_assoc($res_numblanco)) {
            $num_blanco = $row_numblanco["_COUNT"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'num_blanco' => $num_blanco));

      break;

    case 'get_NumBlancoPulverizado':
      $r = array();
      $estado = 0;
      $num_blanco = 0;

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');

      // Obteniendo el correlativo
        $q_numblanco = "SELECT  COUNT(Id) AS _COUNT
                          FROM  Detalle_Rack
                         WHERE  DATE(FechaRegistro_Muestra) = '".$date."'
                           AND  Rack_TipoMuestra = 3";

        if ($res_numblanco = mysqli_query($enlace, $q_numblanco)) {
          if (mysqli_num_rows($res_numblanco) > 0) {
            $estado = 1;

            while ($row_numblanco = mysqli_fetch_assoc($res_numblanco)) {
              $num_blanco = $row_numblanco["_COUNT"];
            }
          }
        }

      echo json_encode(array('estado' => $estado, 'num_blanco' => $num_blanco));

      break;

    case 'get_NomBlancoPulverizado':
      $r = array();
      $estado = 0;

      $q_nomblanco = "SELECT  nom_nomenclatura
                        FROM  tbconfig_BlancoPulverizado_Nomenclatura
                       WHERE  en_ejecucion = 1";

      if ($res_nomblanco = mysqli_query($enlace, $q_nomblanco)) {
        if (mysqli_num_rows($res_nomblanco) > 0) {
          $estado = 1;

          while ($row_nomblanco = mysqli_fetch_assoc($res_nomblanco)) {
            $nom_blanco = $row_nomblanco["nom_nomenclatura"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'nom_blanco' => $nom_blanco));

      break;

    case 'get_ListaMaterialR':
      $r = array();
      $estado = 0;

      $order = (($_GET["orden"] == 1) ? 'ASC' : 'DESC');

      $q_MaterialR = "SELECT CONCAT('(', TBF.abv_tipoblanco, ') - ', Nom_MaterialReferencia) AS Nom_MaterialReferencia
                        FROM tbconfig_MaterialReferencia MR
                             INNER JOIN tbconfig_RackTipoBlancoFundente TBF ON MR.Id_TipoBlancoFundente = TBF.Id
                       WHERE Estado_MaterialReferencia = 'A'
                      ORDER BY Id_TipoBlancoFundente ".$order.", Nom_MaterialReferencia";

      if ($res_MaterialR = mysqli_query($enlace, $q_MaterialR)) {
        if (mysqli_num_rows($res_MaterialR) > 0) {
          while($row_MaterialR = mysqli_fetch_assoc($res_MaterialR)) {
            array_push($r, $row_MaterialR);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaHornos':
      $r = array();
      $estado = 0;

      $q_Hornos = "SELECT Id,
                          CONCAT(cod_horno, ' | Capacidad: ', capacidad_horno, ' Crisoles') AS NOM_HORNO
                     FROM tbconfig_Hornos
                    WHERE estado_horno = 'A'";

      if ($res_Hornos = mysqli_query($enlace, $q_Hornos)) {
        if (mysqli_num_rows($res_Hornos) > 0) {
          while($row_Hornos = mysqli_fetch_assoc($res_Hornos)) {
            array_push($r, $row_Hornos);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaMuestrasNewmont':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];
      $ci_muestra = $_GET["CI_Muestra"];

      $q_Muestras = "SELECT 0 AS Item,
                            PNC.CI_Muestra,
                            M.num_malla,
                            CASE WHEN PNC.Cierre_Newmont = 0 THEN 'NO' ELSE 'SÍ' END AS Cierre_Newmont,
                            PNC.FechaHora_Recepcion,
                            PNC.UsuarioCierre_Newmont,
                            PNC.FechaCierre_Newmont,
                            PNC.Id,
                            PNC.ReOpen_Newmont
                      FROM  Preparacion_Newmont_Cabecera PNC
                            LEFT JOIN tbconfig_Mallas M ON PNC.Id_NumMalla = M.Id
                     WHERE  1 = 1";

      if ($ci_muestra != "0"){
        $q_Muestras .= "   AND PNC.CI_Muestra = '".$ci_muestra."'";
      }
      else{
        $q_Muestras .= "   AND DATE(PNC.FechaHora_Recepcion) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'";
      }

      $q_Muestras .= " ORDER BY FechaHora_Recepcion DESC, Id_Detalle DESC";

      if ($res_Muestras = mysqli_query($enlace, $q_Muestras)) {
        if (mysqli_num_rows($res_Muestras) > 0) {
          while($row_Muestras = mysqli_fetch_assoc($res_Muestras)) {
            array_push($r, $row_Muestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaMuestrasNewmont_Detalle':
      $r = array();
      $estado = 0;

      $Id_Cabecera = $_GET["Id_Cabecera"];

      $q_Detalle = "SELECT Num_Grupo,
                           Peso_muestra,
                           PesoPositivo_Muestra,
                           PesoNegativo_Muestra,
                           UsuarioPeso_Muestra,
                           FechaPeso_Muestra,
                           UsuarioPesoPositivo_Muestra,
                           FechaPesoPositivo_Muestra,
                           UsuarioPesoNegativo_Muestra,
                           FechaPesoNegativo_Muestra,
                           Id_Cabecera,
                           Id
                      FROM Preparacion_Newmont_Detalle
                     WHERE Id_Cabecera = ".$Id_Cabecera."
                    ORDER BY Num_Grupo";

      if ($res_Detalle = mysqli_query($enlace, $q_Detalle)) {
        if (mysqli_num_rows($res_Detalle) > 0) {
          while($row_Detalle = mysqli_fetch_assoc($res_Detalle)) {
            array_push($r, $row_Detalle);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaNumMallas':
      $r = array();
      $estado = 0;

      $q_NumMallas = "SELECT  Id,
                              num_malla
                        FROM  tbconfig_Mallas
                       WHERE  estado_malla = 'A'";

      if ($res_NumMallas = mysqli_query($enlace, $q_NumMallas)) {
        if (mysqli_num_rows($res_NumMallas) > 0) {
          while($row_NumMallas = mysqli_fetch_assoc($res_NumMallas)) {
            array_push($r, $row_NumMallas);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_LimitePesos':
      $r = array();
      $estado = 0;
      $limite_pesos = "";

      $id_limitepesos = $_GET["id_limitepesos"];
      $send_peso = $_GET["send_peso"];

      $q_LimitePesos = "SELECT  Peso_Aprox,
                                Limite_Min,
                                Limite_Max,
                                Limite_Porc
                          FROM  tbconfig_LimitePesos
                         WHERE  Id = ".$id_limitepesos;

      if ($res_LimitePesos = mysqli_query($enlace, $q_LimitePesos)) {
        if (mysqli_num_rows($res_LimitePesos) > 0) {
          while($row_LimitePesos = mysqli_fetch_assoc($res_LimitePesos)) {
            $peso_aprox = $row_LimitePesos["Peso_Aprox"];
            $limit_min = $row_LimitePesos["Limite_Min"];
            $limit_max = $row_LimitePesos["Limite_Max"];
            $limite_porc = $row_LimitePesos["Limite_Porc"];

            if ($limite_porc == 1){
              if ($id_limitepesos == 2){
                $limit_min = $send_peso - ($send_peso * ($limit_min / 100));
                $limit_max = $send_peso + ($send_peso * ($limit_max / 100));
              }
              else{
                $limit_min = $peso_aprox - ($peso_aprox * ($limit_min / 100));
                $limit_max = $peso_aprox + ($peso_aprox * ($limit_max / 100));
              }
            }
            else{
              $limit_min = $peso_aprox - $limit_min;
              $limit_max = $peso_aprox + $limit_max;
            }

            $limite_pesos = $peso_aprox."|".$limit_min."|".$limit_max;
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'limite_pesos' => $limite_pesos));

      break;

    case 'guardar_PesosMuestrasNewmont':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Muestra"];
      $Id_Cabecera = $_GET["Id_Cabecera"];
      $Id_Detalle = $_GET["Id_Detalle"];
      $Num_Malla = $_GET["Num_Malla"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Peso = $_GET["Usuario_Peso"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $q_SavePeso = "UPDATE Preparacion_Newmont_Detalle
                            SET Peso_Muestra = ".$Peso_Muestra.",
                                FechaPeso_Muestra = '".($date.' ' .$time)."',
                                UsuarioPeso_Muestra = '".$Usuario_Peso."'
                          WHERE Id = ".$Id_Detalle;
        }

      // Para el peso de Positivos
        if ($Tipo_Peso == 'P'){
          $q_SavePeso = "UPDATE Preparacion_Newmont_Detalle
                            SET PesoPositivo_Muestra = ".$Peso_Muestra.",
                                FechaPesoPositivo_Muestra = '".($date.' ' .$time)."',
                                UsuarioPesoPositivo_Muestra = '".$Usuario_Peso."',

                                PesoNegativo_Muestra = (Peso_Muestra - ".$Peso_Muestra."),
                                FechaPesoNegativo_Muestra = '".($date.' ' .$time)."',
                                UsuarioPesoNegativo_Muestra = '".$Usuario_Peso."'
                          WHERE Id = ".$Id_Detalle;
        }

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Actualiza el número de Malla
          $q_update = "UPDATE Preparacion_Newmont_Cabecera
                          SET Id_NumMalla = ".$Num_Malla."
                        WHERE Id = ".$Id_Cabecera;

          if ($res_update = mysqli_query($enlace, $q_update)) {
          }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_Newmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $usuario_cierre = $_GET["Usuario_Cierre"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      $q_CierreNewmont = "UPDATE Preparacion_Newmont_Cabecera
                             SET Cierre_Newmont = 1,
                                 FechaCierre_Newmont = '".($date.' ' .$time)."',
                                 UsuarioCierre_Newmont = '".$usuario_cierre."'
                           WHERE Id = ".$id_cabecera;

      if ($res = mysqli_query($enlace, $q_CierreNewmont)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'reopen_Newmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $usuario_cierre = $_GET["Usuario_Cierre"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      $q_ReOpenNewmont = "UPDATE Preparacion_Newmont_Cabecera
                             SET Cierre_Newmont = 0,
                                 FechaCierre_Newmont = null,
                                 UsuarioCierre_Newmont = null,
                                 ReOpen_Newmont = 1,
                                 FechaReOpen_Newmont = '".($date.' ' .$time)."',
                                 UsuarioReOpen_Newmont = '".$usuario_cierre."'
                           WHERE Id = ".$id_cabecera;

      if ($res = mysqli_query($enlace, $q_ReOpenNewmont)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'reopen_EliminarPesos_Newmont':
      $r = array();
      $estado = 0;

      $id_detalle = $_GET["Id_Detalle"];
      $usuario_eliminarpesoslog = $_GET["Usuario_EliminarPesosLog"];

      // Inserta los datos a actualizar en la tabla de Log
      $q_SaveLog = "INSERT INTO Preparacion_Newmont_Detalle_ReOpenLog (Id_Detalle, Id_Cabecera, Num_Grupo, Peso_muestra,
                                FechaPeso_Muestra, UsuarioPeso_Muestra, PesoPositivo_muestra, FechaPesoPositivo_Muestra,
                                UsuarioPesoPositivo_Muestra, PesoNegativo_muestra, FechaPesoNegativo_Muestra, UsuarioPesoNegativo_Muestra,
                                Usuario_ReOpenLog)

                    SELECT  Id, Id_Cabecera, Num_Grupo, Peso_muestra,
                            FechaPeso_Muestra, UsuarioPeso_Muestra, PesoPositivo_muestra, FechaPesoPositivo_Muestra,
                            UsuarioPesoPositivo_Muestra, PesoNegativo_muestra, FechaPesoNegativo_Muestra, UsuarioPesoNegativo_Muestra,
                            '".$usuario_eliminarpesoslog."'
                      FROM  Preparacion_Newmont_Detalle
                     WHERE  Id = ".$id_detalle;

      if ($res_SaveLog = mysqli_query($enlace, $q_SaveLog)) {
        $estado = 1;

        // Limpia los datos de la tabla de detalles
          $q_update = "UPDATE Preparacion_Newmont_Detalle
                          SET Peso_muestra = 0,
                              FechaPeso_Muestra = null,
                              UsuarioPeso_Muestra = null,

                              PesoPositivo_muestra = 0,
                              FechaPesoPositivo_Muestra = null,
                              UsuarioPesoPositivo_Muestra = null,

                              PesoNegativo_muestra = 0,
                              FechaPesoNegativo_Muestra = null,
                              UsuarioPesoNegativo_Muestra = null
                        WHERE Id = ".$id_detalle;

          if ($res_update = mysqli_query($enlace, $q_update)) {
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_VerificaMuestraNewmont':
      $r = array();
      $estado = 0;

      $ci_muestra = $_GET["CI_Muestra"];
      $id_rack = $_GET["Id_Rack"];

      // Comprobando si es una muestra Newmont
        $q_newmont = "SELECT  COUNT(Id) AS _EXISTS
                        FROM  _max_labperu_DetallePedido
                       WHERE  Cod_Interno = '".$ci_muestra."'
                         AND  IdProductos_Combo LIKE '%43121%'";

        if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
          while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
            $estado = $row_newmont["_EXISTS"];

            if ($estado == 0){
              echo json_encode(array('estado' => $estado));

              return;
            }

            // Comprobando si se registraron todos los pesos para los Grupos Newmont
              $q_GruposNewmont = "SELECT  COUNT(Id) AS _COUNT
                                    FROM  Preparacion_Newmont_Detalle
                                   WHERE  Id_Cabecera IN (SELECT Id
                                                FROM Preparacion_Newmont_Cabecera
                                               WHERE CI_Muestra = '".$ci_muestra."')
                                     AND  Reanalisis_Por_Positivo = 0";

              if ($res_GruposNewmont = mysqli_query($enlace, $q_GruposNewmont)) {
                if (mysqli_num_rows($res_GruposNewmont) > 0) {
                  while($row_GruposNewmont = mysqli_fetch_assoc($res_GruposNewmont)) {
                    $num_grupospreparacion = $row_GruposNewmont["_COUNT"];

                    // Verificando los grupos que tengan peso en Fundición
                      $q_PesosFundicion = "SELECT COUNT(Group_Newmont) AS _COUNT
                                             FROM Detalle_Rack
                                            WHERE ci_muestra = '".$ci_muestra."'";

                      if ($res_PesosFundicion = mysqli_query($enlace, $q_PesosFundicion)) {
                        if (mysqli_num_rows($res_PesosFundicion) > 0) {
                          while($row_PesosFundicion = mysqli_fetch_assoc($res_PesosFundicion)) {
                            $num_gruposfundcion = $row_PesosFundicion["_COUNT"];

                            if ($num_grupospreparacion == $num_gruposfundcion){
                              $estado = 4;

                              echo json_encode(array('estado' => $estado));

                              return;
                            }
                          }
                        }
                      }
                  }
                }
              }

            // Comprueba que la muestra esté cerrada desde Preparación
              $q_CierreNewmont = "SELECT  COUNT(Id) AS _COUNT
                                    FROM  Preparacion_Newmont_Cabecera
                                   WHERE  CI_Muestra = '".$ci_muestra."'
                                     AND  Cierre_Newmont = 1";

              if ($res_CierreNewmont = mysqli_query($enlace, $q_CierreNewmont)) {
                if (mysqli_num_rows($res_CierreNewmont) > 0) {
                  while($row_CierreNewmont = mysqli_fetch_assoc($res_CierreNewmont)) {
                    if ($row_CierreNewmont["_COUNT"] == 0){
                      $estado = 2;

                      echo json_encode(array('estado' => $estado));

                      return;
                    }
                  }
                }
              }

            // // Comprobar que la muestra no exista en otro Rack
            //   $q_exists = "SELECT  COUNT(Id) AS _COUNT
            //                  FROM  Detalle_Rack
            //                 WHERE  ci_muestra = '".$ci_muestra."'
            //                   AND  is_Reanalisis = 0
            //                   AND  Id_Rack <> ".$id_rack;

            //   if ($res_exists = mysqli_query($enlace, $q_exists)) {
            //     if (mysqli_num_rows($res_exists) > 0) {
            //       while($row_exists = mysqli_fetch_assoc($res_exists)) {
            //         if ($row_exists["_COUNT"] > 0){
            //           $estado = 3;

            //           echo json_encode(array('estado' => $estado));

            //           return;
            //         }
            //       }
            //     }
            //   }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaGruposNewmont':
      $r = array();
      $estado = 0;

      $ci_muestra = $_GET["CI_Muestra"];

      // Verificando los grupos que ya tengan peso en Fundición
        $in_gruponewmont = '';

        $q_PesosFundicion = "SELECT Group_Newmont
                               FROM Detalle_Rack
                              WHERE ci_muestra = '".$ci_muestra."'";

        if ($res_PesosFundicion = mysqli_query($enlace, $q_PesosFundicion)) {
          if (mysqli_num_rows($res_PesosFundicion) > 0) {
            while($row_PesosFundicion = mysqli_fetch_assoc($res_PesosFundicion)) {
              $in_gruponewmont .= $row_PesosFundicion["Group_Newmont"].", ";
            }

            $in_gruponewmont = substr($in_gruponewmont, 0, -2);
          }
        }

        if (strlen($in_gruponewmont) == 0){
          $in_gruponewmont = "''";
        }

      // Obtiene los grupos disponibles
        $q_GruposNewmont = "SELECT  Id,
                                    CONCAT('Grupo ', Num_Grupo) AS NUM_GRUPO
                              FROM  Preparacion_Newmont_Detalle
                             WHERE  Id_Cabecera IN (SELECT Id
                                                      FROM Preparacion_Newmont_Cabecera
                                                     WHERE CI_Muestra = '".$ci_muestra."')
                               AND  Reanalisis_Por_Positivo = 0
                               AND Id NOT IN (".$in_gruponewmont.")";

        if ($res_GruposNewmont = mysqli_query($enlace, $q_GruposNewmont)) {
          if (mysqli_num_rows($res_GruposNewmont) > 0) {
            while($row_GruposNewmont = mysqli_fetch_assoc($res_GruposNewmont)) {
              array_push($r, $row_GruposNewmont);
            }

            $estado = 1;
          }
        }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_PesoPositivoPreparacion':
      $r = array();
      $estado = 0;
      $peso_positivo = 0;

      $id_detalle_preparacion = $_GET["Id_Detalle_Preparacion"];

      $q_PesoPositivo = "SELECT  PesoPositivo_muestra
                           FROM  Preparacion_Newmont_Detalle
                          WHERE  Id = ".$id_detalle_preparacion;

      if ($res_PesoPositivo = mysqli_query($enlace, $q_PesoPositivo)) {
        if (mysqli_num_rows($res_PesoPositivo) > 0) {
          $estado = 1;

          while ($row_PesoPositivo = mysqli_fetch_assoc($res_PesoPositivo)) {
            $peso_positivo = $row_PesoPositivo["PesoPositivo_muestra"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'peso_positivo' => $peso_positivo));

      break;

    case 'guardar_PesoMuestraNewmont_Rack':
      $r = array();
      $estado = 0;
      $exists = 0;

      $positivo_negativo = $_GET["Positivo_Negativo"];
      $ci_muestra = $_GET["CI_Muestra"];
      $id_rack = $_GET["Id_Rack"];
      $num_crisol = $_GET["Num_Crisol"];
      $id_gruponewmont = $_GET["Id_GrupoNewmont"];
      $nom_gruponewmont = $_GET["Nom_GrupoNewmont"];
      $tipo_blanco = $_GET["Tipo_Blanco"];
      $dosificacion = $_GET["Dosificacion"];
      $peso_muestra = $_GET["Peso_Muestra"];
      $usuario_peso = $_GET["Usuario_Peso"];

      // Busca la muestra en las tablas de ventas
        $q_RackMuestra = "SELECT  C.Id_Pedido,
                                  D.Id AS Id_Detalle,
                                  D.Cod_Interno,
                                  D.Nom_Muestra,
                                  PV.Id_MedioPago
                            FROM  _max_labperu_DetallePedido D
                                  INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                  INNER JOIN _max_labperu_PagoVenta PV ON C.Id_Pedido = PV.Id_Pedido
                           WHERE  D.Cod_Interno = '".$ci_muestra."'";

        if ($res_RackMuestra = sqlsrv_query($enlacehost, $q_RackMuestra)) {
          while($row_RackMuestra = sqlsrv_fetch_array($res_RackMuestra)) {
            $nom_muestra = trim($row_RackMuestra["Nom_Muestra"]);

            if ($positivo_negativo == "P"){
              // Guardando en la tabla Detalle_Rack
                $q_InsertDetalle = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                                             ci_muestra, nom_muestra, is_Au, is_Ag,
                                                             is_Newmont, Group_Newmont, Id_TipoBlancoFundente, Dosificacion,
                                                             num_replica, Id_MedioPago, is_Reanalisis) VALUES(";
                $q_InsertDetalle .= $id_rack.", ";
                $q_InsertDetalle .= $row_RackMuestra["Id_Pedido"].", ";
                $q_InsertDetalle .= $row_RackMuestra["Id_Detalle"].", 1, ";
                $q_InsertDetalle .= "'".$ci_muestra."', ";
                $q_InsertDetalle .= "'".$nom_muestra."', 0, 0, 1, ";
                $q_InsertDetalle .= $id_gruponewmont.", ";
                $q_InsertDetalle .= $tipo_blanco.", ";
                $q_InsertDetalle .= "'".$dosificacion."', 0, ";
                $q_InsertDetalle .= $row_RackMuestra["Id_MedioPago"].", 0)";

                if ($res_InsertDetalle = mysqli_query($enlace, $q_InsertDetalle)) {
                  // Obteniendo Id
                    $q_Id = "SELECT Id
                               FROM Detalle_Rack
                             ORDER BY Id DESC
                             LIMIT 1";
                }
            }
            else{
              $q_Id = "SELECT Id
                         FROM Detalle_Rack
                        WHERE ci_muestra = '".$ci_muestra."'";
            }

            // Obtiene el Id de la tabla Detalle_Rack
              if ($res_Id = mysqli_query($enlace, $q_Id)) {
                if (mysqli_num_rows($res_Id) > 0) {
                  while ($row_Id = mysqli_fetch_assoc($res_Id)) {
                    $id_detalle_rack = $row_Id["Id"];
                  }
                }
              }

            // Guardar Pesos
              $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra, ";
              $q_SavePeso .= (($positivo_negativo == 'P') ? "is_Newmont_Positivo" : "is_Newmont_Negativo").") VALUES(";
              $q_SavePeso .= $id_detalle_rack.", ";
              $q_SavePeso .= $num_crisol.", ";
              $q_SavePeso .= "'".$ci_muestra.(($positivo_negativo == 'P') ? ' (+'.$nom_gruponewmont.')' : ' (-'.$nom_gruponewmont.')')."', ";
              $q_SavePeso .= $peso_muestra.", ";
              $q_SavePeso .= "'".$usuario_peso."', ";
              $q_SavePeso .= "1)";

              if ($res = mysqli_query($enlace, $q_SavePeso)) {
                $estado = 1;
              }
              else{
                $estado = 0;
              }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    default:

      # code...

      break;

  }

?>